0103abc
0103abc 的网站
= 算法、题解与学习记录 =
文章列表
有经典结论: 在一个凸包上, 每次选择最小的三角形并将其顶点从凸包上删除, 得到的所有三角形的面积单调不下降. 证明拿叉积算一下就行。 于是容易证明, 根据这个策略, 若 $n$ 为偶数则先手必胜, 否则先手会多取走一个三角形, 后手必胜。 $n$ 很小, 所以直接暴力模拟该过程, 时间复杂度为...
难度:$4/10$ 考虑下面的几个性质(这也太难了): 对于给定的两个串 $s1,s2$,其中任意一个位置 $i$ 均满足 $s1i$ 和 $s2{n-i+1}$ 相对位置不会改变。 对于任意一个位置 $i$,字符对 $(s1i,s2{n-i+1})$...
建议先阅读 CF1144G 题解。 直接按照上述做法暴力判断可以做到 $O(n^2)$ 求解,但是这显然过不去。 考虑换一个枚举顺序:从大到小枚举左端点 $l$,然后从 $l$ 位置开始往右扫 $r$。在向左移动左端点 $l$ 的过程中,若对于某个扫描到的右端点位置 $r$,其两个 dp...
难度:$2.5/10$ 简单 dp。容易想到设 $f_{i,0/1}$ 表示当前处理了前 $i$ 个数: $0$:当前元素处于递增序列中,递减序列最后一个元素的最大值。 $1$:当前元素处于递减序列中,递增序列最后一个元素的最小值。 转移是容易的,分四类讨论当前元素和上一个元素分别位于递增序列 /...
知道 Ramsey 数就很简单,注意到 $R(6,3)\le 46$,所以对于 $n\ge 46$ 的情况必然可以构造出一组合法的解,因此直接把 $n$ 对 $50$ 取 $\min$ 然后暴力枚举即可。
难度:$3/10$ 感觉是没啥难度的题。先考虑一个暴力的 dp:设 $fi$ 表示当前处理了 $i$ 集合内所有的简单路径,至少需要染几条边。初始条件是 $f0=0$。然后再维护一下 $gi$ 表示 $i$ 连向其父亲的边被哪些简单路径覆盖了,转移就是简单的了,直接 $f{i\cup...
给定 $n,r$,求 $\sum\limits_{d=1}^n(-1)^{\lfloor d\sqrt r\rfloor}$ 的值。 Sol 3 先考虑一个经典结论: (-1)^x=1-2[x\bmod 2=1] 然后考虑从这个结论入手来获取一些有用的信息: \begin{aligned}...
十分好的不含杂质 Ad-Hoc 构造!难度:$8/10$,另外几道有难度然后这么好玩的构造题应该是 P12336 第三心脏(比这个题简单一点),[P14025 [ICPC 2024 Nanjing R] P ⊕ Q = R](https:/...
难度:$3/10$。 比较无聊的题。先考虑一个比较暴力的做法。枚举根 $R$,然后再枚举点集 $S$ 的 LCA 所在位置 $i$。可以一遍 dfs 求出 $siz_i$ 数组表示 $i$ 点为根的子树,然后直接组合数统计答案。具体的,固定 $R,i$ 后的答案为:...
容易证明,对于题目中给出的式子: \min{1\le i\le n}\left(\max{1\le j\le m}a{i,j}\right)\le\max{1\le j\le m}\left(\min{1\le i\le n}a{i,j}\right) 若要其成立,则当且仅当: \min{1\le...